function ObjectJc_genBus 
  % this script initializes a set of bus objects in the MATLAB base workspace 
  % generated by simulinkSfuncBusGen.jzcmd

            
  % Bus object: ObjectJc 
  clear ObjectJc_elems;
  ix = 1;

ObjectJc_elems(ix) = Simulink.BusElement;
ObjectJc_elems(ix).Name = 'ownAddr';
ObjectJc_elems(ix).Dimensions = 2;
ObjectJc_elems(ix).DimensionsMode = 'Fixed';
ObjectJc_elems(ix).DataType = 'uint32';
ObjectJc_elems(ix).SampleTime = -1;
ObjectJc_elems(ix).Complexity = 'real';
ObjectJc_elems(ix).SamplingMode = 'Sample based';
ObjectJc_elems(ix).Min = [];
ObjectJc_elems(ix).Max = [];
ObjectJc_elems(ix).DocUnits = '';

ObjectJc_elems(ix).Description = 'The own address of the original data. ';

ix = ix+1;

ObjectJc_elems(ix) = Simulink.BusElement;
ObjectJc_elems(ix).Name = 'reflAddr';
ObjectJc_elems(ix).Dimensions = 2;
ObjectJc_elems(ix).DimensionsMode = 'Fixed';
ObjectJc_elems(ix).DataType = 'uint32';
ObjectJc_elems(ix).SampleTime = -1;
ObjectJc_elems(ix).Complexity = 'real';
ObjectJc_elems(ix).SamplingMode = 'Sample based';
ObjectJc_elems(ix).Min = [];
ObjectJc_elems(ix).Max = [];
ObjectJc_elems(ix).DocUnits = '';

ObjectJc_elems(ix).Description = 'The address of the reflection Info of the type. ';

ix = ix+1;

ObjectJc_elems(ix) = Simulink.BusElement;
ObjectJc_elems(ix).Name = 'identSize';
ObjectJc_elems(ix).Dimensions = 1;
ObjectJc_elems(ix).DimensionsMode = 'Fixed';
ObjectJc_elems(ix).DataType = 'uint32';
ObjectJc_elems(ix).SampleTime = -1;
ObjectJc_elems(ix).Complexity = 'real';
ObjectJc_elems(ix).SamplingMode = 'Sample based';
ObjectJc_elems(ix).Min = [];
ObjectJc_elems(ix).Max = [];
ObjectJc_elems(ix).DocUnits = '';

ObjectJc_elems(ix).Description = 'Identification number and size information, see definition of ObjectJc. ';

ix = ix+1;

ObjectJc_elems(ix) = Simulink.BusElement;
ObjectJc_elems(ix).Name = 'state';
ObjectJc_elems(ix).Dimensions = 1;
ObjectJc_elems(ix).DimensionsMode = 'Fixed';
ObjectJc_elems(ix).DataType = 'uint32';
ObjectJc_elems(ix).SampleTime = -1;
ObjectJc_elems(ix).Complexity = 'real';
ObjectJc_elems(ix).SamplingMode = 'Sample based';
ObjectJc_elems(ix).Min = [];
ObjectJc_elems(ix).Max = [];
ObjectJc_elems(ix).DocUnits = '';

ObjectJc_elems(ix).Description = 'Different state information, special usage. ';


            
ObjectJc = Simulink.Bus;
ObjectJc.HeaderFile = 'Fwc/ObjectBaseC.h';
ObjectJc.Description = 'This structure is a basic structure to forward data to Inspector blocks and for further ObjectOrientation.';
ObjectJc.DataScope = 'Imported';
ObjectJc.Alignment = -1;
ObjectJc.Elements = ObjectJc_elems;
assignin('base','ObjectJc', ObjectJc);

            
