

#include <SharedMemExmpl.h>
#include <SPEdata.h>

SharedMemExmpl::SharedMemExmpl() 
  : yMax(2.4f), Tctrl(0.000050f)
  , par_pid(0, this->Tctrl, this->yMax)
	, pid(&par_pid,0) 
{
		

}

void SharedMemExmpl::init()
{
	void* addr = os_openSharedMem(&this->shMemMng, "testVishiaInspc", 1000, false);
	this->speData = C_CAST(SPEdata_s*, addr);
	float yMax = 2.4f;
  float kP = 1.0f;
  float Ti = 0.020f;
  float Td = 0.010f;
  float Tsd = 0.0001f;
  this->par_pid.init(this->Tctrl, this->yMax, kP, Ti, Td, Tsd, false, false);
	this->pid.init(&this->par_pid);

}

void SharedMemExmpl::step()
{
	this->speData->y = this->step(this->speData->w, this->speData->x);
	this->speData->step = 1;

}

float SharedMemExmpl::step(float w, float x) {
	float y;
	pid.step(w - x, &y);

	return y;

}




void step_SharedMemExmpl ( SharedMemExmpl_s* thiz) {
  thiz->speData->y = thiz->speData->w - thiz->speData->x;

}



void dtor_SharedMemExmpl ( SharedMemExmpl_s* thiz) {

  os_closeSharedMem(&thiz->shMemMng);

}
