#ifndef HGUARD_SharedMemExmpl
#define HGUARD_SharedMemExmpl
#include <emC/Base/Object_emC.h>
#include <emC/OSAL/os_sharedmem.h>

//#include <SPEdata.h>
#include <emC/Ctrl/PIDf_Ctrl_emC.h>

struct SPEdata_t;

typedef struct SharedMemExmpl_T {

  union { ObjectJc object; } base;


  SharedMem_OSAL shMemMng;


  struct SPEdata_t* speData;



} SharedMemExmpl_s;




class SharedMemExmpl :public SharedMemExmpl_s {

  public: PIDf_Ctrl_emC pid;
  public: Par_PIDf_Ctrl_emC par_pid;

  public: SharedMemExmpl();

  public: void init();

  public: void step();

  public: float step(float w, float x);

  private: 
    float const yMax;   //:max value for the controller output, hard limit
    float const Tctrl;  //:step time for control
};




extern_C void ctor_SharedMemExmpl ( SharedMemExmpl_s* thiz);

extern_C void dtor_SharedMemExmpl ( SharedMemExmpl_s* thiz);

extern_C void init_SharedMemExmpl ( SharedMemExmpl_s* thiz);

extern_C void step_SharedMemExmpl ( SharedMemExmpl_s* thiz);



#endif //HGUARD_SharedMemExmpl
