#ifndef __SPEdata_h__
#define __SPEdata_h__
#include <applstdef_emC.h>
#include <emC/Base/Object_emC.h>





typedef struct SPEdata_t {
  union { ObjectJc_DataStruct object; } base;  //Note: #define ObjectJc_DataStruct ObjectJc ... or ObjectFullJc

  int32 step;

  float x;

  float w;

  float y;
} SPEdata_s;

extern_C ClassJc const refl_SPEdata;

void ctor_SPEdata(SPEdata_s* thiz);


/**Write data to DataStruct. 
 * Note: The Simulink coder cannot decide whether it is a scalar, vector or pointer
 * Therefore all arguments are unique given as address (pointer) 
 */

bool init__SPEdata(SPEdata_s* thiz, int32 const* step, float const* y);


void step__SPEdata(SPEdata_s* thiz, float const* x, float const* w);


inline void get_step_SPEdata(SPEdata_s* thiz, int32* step) {
  *step = thiz->step;
}

inline void get_x_SPEdata(SPEdata_s* thiz, float* x) {
  *x = thiz->x;
}

inline void get_w_SPEdata(SPEdata_s* thiz, float* w) {
  *w = thiz->w;
}

inline void get_y_SPEdata(SPEdata_s* thiz, float* y) {
  *y = thiz->y;
}
#endif  //__SPEdata_h__

